;DEMO 2
;Infinite Ray to mesh collision.

;fixed direction bug in example code




;Include helper functions and needed globals
Include "coldet.bb"



Graphics3D 640,480,0,2


;activate some global variables
coldet_start()


cam=CreateCamera()
MoveEntity cam,0,3,-5
light=CreateLight()



;------------------------------
;create a "ray like triangle" near the camera's position
ray=CreateMesh()
rs=CreateSurface(ray)
v0=AddVertex(rs,-.03,0,-5)
v1=AddVertex(rs,0,0,+50)
v2=AddVertex(rs,.03,0,-5)
AddTriangle(rs,v0,v1,v2)
EntityColor ray,255,255,0
UpdateNormals ray
EntityFX ray,16


;Set the rays origin in the ray_origin bank
PokeFloat ray_origin,0,0
PokeFloat ray_origin,4,0
PokeFloat ray_origin,8,-5

;and the start direction
PokeFloat ray_direction,0,(0-0)
PokeFloat ray_direction,4,(0-0)
PokeFloat ray_direction,8,(50-(-5))

;------------------------------




;------------------------------
;this is the static mesh
ob1=CreateSphere(32)
EntityColor ob1,255,0,0

;Make the coldet models and get their pointers !
;Careful ! Do not use by mistake blitz's pointers.
c_ob1 = coldet_make(ob1,0);0=static

;------------------------------


;variables to control the ray
rx#=0
ry#=0


sp=CreateSphere()
ScaleEntity sp,.05,.05,.05

PointEntity cam,ob1




	
While Not KeyHit(1)

RenderWorld()


;move the ray
If KeyDown(200) ry=ry+.2 update_ray(rs,v1,rx#,ry#)
If KeyDown(208) ry=ry-.2 update_ray(rs,v1,rx#,ry#)
If KeyDown(203) rx=rx-.2 update_ray(rs,v1,rx#,ry#)
If KeyDown(205) rx=rx+.2 update_ray(rs,v1,rx#,ry#)






res=coldet_ray_collision2(c_ob1,ray_origin,ray_direction);if a collision occurs between ray and model
	Text 10,10,res
	
	If res
	coldet_collision_point(c_ob1,0);get the collision point
	Text 10,20,"x: "+collision_point_x()
	Text 10,30,"y: "+collision_point_y()
	Text 10,40,"z: "+collision_point_z()
	PositionEntity sp,collision_point_x(),collision_point_y(),collision_point_z()
	EndIf

	Text 10,60,"tri1: "+coldet_colliding_tri(c_ob1,0);model1 colliding tri
	
Text 200,0,"[ Cursor keys move the ray ]"
		
Flip

Wend




;FREE THE COLDET MODELS FROM MEMORY !
coldet_free_model(c_ob1)


;free global stuff
coldet_end()



End




;quick and dirty function to update the ray and it's direction bank
Function update_ray(rs,v1,rx#,ry#)
VertexCoords rs,v1,rx,ry,50
PokeFloat ray_direction,0,(rx#-0)
PokeFloat ray_direction,4,(ry#-0)
PokeFloat ray_direction,8,(50.0-(-5.0))

End Function