//Coldet wrapper dll.
//final version 1.0
//By Elias Tsiantas
//Original Coldet library : http://photoneffect.com/coldet/
//ColDet - 3D Collision Detection Library
//Copyright (C) 2000  Amir Geva


#include "coldet.h"



#define DLL extern "C" __declspec(dllexport) 



//Check for collision between model a and b.
DLL int _stdcall colldet_collision(void*a, void*b){



CollisionModel3D*model= static_cast<CollisionModel3D*>(a);
CollisionModel3D*model2= static_cast<CollisionModel3D*>(b);


return model->collision (model2);

}




//get collision point using _this model.
DLL void _stdcall get_collision_point(void*a,float*p,bool global){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

model->getCollisionPoint(p, global);

	}


//get the colliding tris vertexpositions using _this model.
DLL void _stdcall getcolliding_tris1(void*a,float*t1,float*t2){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

model->getCollidingTriangles(t1, t2, 0);

}


//get the colliding tris indexes using _this model.
DLL void _stdcall getcolliding_tris2(void*a,int&t1,int&t2){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

model->getCollidingTriangles(t1, t2);

}


  /** Returns true if the ray given in world space coordinates
      intersects with the object.  
      getCollidingTriangles() and getCollisionPoint() can be
      used to retrieve information about a collision.
      If closest if false, the first triangle that collides with
      the ray is used.  Otherwise the closest one will be used.
      Closest triangle searching will slow the test considerably.
      The default ray is a standard infinite ray.  However, using
      segmin and segmax you can define a line segment along the
      ray.
  */

//this is a somehow slower version- becaue we pass more parameters to it.
DLL int _stdcall coldet_rayCollision1(void*a,float*origin,
                            float*direction,
                            bool closest,
                            float segmin,
                            float segmax) {


CollisionModel3D*model= static_cast<CollisionModel3D*>(a);


return model->rayCollision(origin,direction,closest,segmin,segmax);

}



//faster version - less parameters passed.
//also this one casts an infinite ray.
DLL int _stdcall coldet_rayCollision2(void*a,float*origin,
                            float*direction) {


CollisionModel3D*model= static_cast<CollisionModel3D*>(a);


return model->rayCollision(origin,direction);

}


  /** Returns true if the given sphere collides with the model.
      getCollidingTriangles() and getCollisionPoint() can be
      used to retrieve information about a collision.
  */
DLL int _stdcall coldet_sphereCollision(void*a,float*origin,
								 float radius){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

return model->sphereCollision(origin,radius);

}







//Construct the coldet model
//trinum is the model's tri number

//stat=0 model=static
//stat=1 model moves abd rotates.

DLL int _stdcall coldet_make_model(int trinum,bool stat){

CollisionModel3D*model = newCollisionModel3D(stat);

if (trinum != 0){
	model->setTriangleNumber(trinum);}

return *((int*)&model);

	}





//add manually a triangle
DLL void _stdcall           coldet_addTriangle ( void*a,
						   float x1, float y1, float z1,
                           float x2, float y2, float z2,
                           float x3, float y3, float z3){


CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

	model->addTriangle(x1,y1,z1,
					   x2,y2,z2,
					   x3,y3,z3);

}




//add all the tris using a memory bank.
//vert is the bank.
//nump=tris*9
DLL void _stdcall coldet_addmod(void*a,float*vert,int nump){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

   
	for (int i=0;
	i<nump;i+=9){
	model->addTriangle(vert[i+0],vert[i+1],vert[i+2],
					   vert[i+3],vert[i+4],vert[i+5],
					   vert[i+6],vert[i+7],vert[i+8]);
	}


}





//set the transformation matrix of the model
//call this whenever you move or rotate a model.
//px,y,z=entity's global position
//rx,y,z=entity's pitch,yaw,roll

//It is also important to note that the transformations should include
//no scaling, as it disrupts the consistency of the collision model.



DLL void _stdcall coldet_set_matrix(void *a,float *mat) {

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

model->setTransform (mat);

}





//call this to finalize a model
//after this no more tris can be added
DLL void _stdcall coldet_finalize(void *a){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

model->finalize ();


}




//free a model from the memory.
DLL void _stdcall coldet_free(void *a){

CollisionModel3D*model= static_cast<CollisionModel3D*>(a);

delete model;

}






//********************************************************************
//UTILITY FUNCTIONS

/** Checks for intersection between a ray and a sphere.
    center, radius define the sphere
    origin, direction define the ray
    point will contain point of intersection, if one is found.
*/
DLL int _stdcall coldet_SphereRayCollision(float*center,float radius,
                        float*origin,float*direction,
                        float*point){

return SphereRayCollision(center,radius,origin,direction,point);

	}






/** Checks for intersection between 2 spheres. */


DLL int _stdcall coldet_SphereSphereCollision(float*c1,float r1,
											  float*c2,float r2,float*p){


return SphereSphereCollision(c1,r1,c2,r2,p);

}






//*******************************************************************






